Index: squid/src/fs/aufs/store_dir_aufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/store_dir_aufs.c,v
retrieving revision 1.1.6.6.2.2
retrieving revision 1.1.6.6.2.3
diff -u -r1.1.6.6.2.2 -r1.1.6.6.2.3
--- squid/src/fs/aufs/store_dir_aufs.c	2 May 2000 22:50:29 -0000	1.1.6.6.2.2
+++ squid/src/fs/aufs/store_dir_aufs.c	14 May 2000 23:22:20 -0000	1.1.6.6.2.3
@@ -1757,28 +1552,28 @@
  * This is called by storeCleanup() if -S was given on the command line.
  */
 static int
-storeAufsCleanupDoubleCheck(SwapDir *sd, StoreEntry *e)
+storeAufsCleanupDoubleCheck(SwapDir * sd, StoreEntry * e)
 {
     struct stat sb;
 
     if (stat(storeAufsDirFullPath(sd, e->swap_filen, NULL), &sb) < 0) {
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: MISSING SWAP FILE\n");
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: PATH %s\n",
-            storeAufsDirFullPath(sd, e->swap_filen, NULL));
-        storeEntryDump(e, 0);
-        return -1;
-    }       
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: MISSING SWAP FILE\n");
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: PATH %s\n",
+	    storeAufsDirFullPath(sd, e->swap_filen, NULL));
+	storeEntryDump(e, 0);
+	return -1;
+    }
     if (e->swap_file_sz != sb.st_size) {
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: SIZE MISMATCH\n");
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: PATH %s\n",
-            storeAufsDirFullPath(sd, e->swap_filen, NULL));
-        debug(20, 0) ("storeAufsCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
-            e->swap_file_sz, (int) sb.st_size); 
-        storeEntryDump(e, 0); 
-        return -1;
-    }       
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: SIZE MISMATCH\n");
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: PATH %s\n",
+	    storeAufsDirFullPath(sd, e->swap_filen, NULL));
+	debug(20, 0) ("storeAufsCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
+	    e->swap_file_sz, (int) sb.st_size);
+	storeEntryDump(e, 0);
+	return -1;
+    }
     return 0;
 }
 
@@ -1788,7 +1583,7 @@
  * Called when a *new* fs is being setup.
  */
 void
-storeAufsDirParse(SwapDir *sd, int index, char *path)
+storeAufsDirParse(SwapDir * sd, int index, char *path)
 {
     char *token;
     int i;
@@ -1816,7 +1611,7 @@
 
     aioinfo = xmalloc(sizeof(aioinfo_t));
     if (aioinfo == NULL)
-        fatal("storeAufsDirParse: couldn't xmalloc() aioinfo_t!\n");
+	fatal("storeAufsDirParse: couldn't xmalloc() aioinfo_t!\n");
 
     sd->index = index;
     sd->path = xstrdup(path);
@@ -1825,7 +1620,7 @@
     aioinfo->l1 = l1;
     aioinfo->l2 = l2;
     aioinfo->swaplog_fd = -1;
-    aioinfo->map = NULL; /* Debugging purposes */
+    aioinfo->map = NULL;	/* Debugging purposes */
     aioinfo->suggest = 0;
     sd->flags.read_only = read_only;
     sd->init = storeAufsDirInit;
@@ -1849,45 +1644,16 @@
     sd->log.open = storeAufsDirOpenSwapLog;
     sd->log.close = storeAufsDirCloseSwapLog;
     sd->log.write = storeAufsDirSwapLog;
-    sd->log.clean.open = storeAufsDirWriteCleanOpen;
+    sd->log.clean.start = storeAufsDirWriteCleanStart;
+    sd->log.clean.nextentry = storeAufsDirCleanLogNextEntry;
+    sd->log.clean.done = storeAufsDirWriteCleanDone;
 
     /* Initialise replacement policy stuff */
-#if HEAP_REPLACEMENT
-    /*
-     * Create new heaps with cache replacement policies attached to them.
-     * The cache replacement policy is specified as either GDSF or LFUDA in
-     * the squid.conf configuration file.  Note that the replacement policy
-     * applies only to the disk replacement algorithm.  Memory replacement
-     * always uses GDSF since we want to maximize object hit rate.
-     */
-    if (Config.replPolicy) {
-        if (tolower(Config.replPolicy[0]) == 'g') {
-            debug(20, 1) ("Using GDSF disk replacement policy\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        } else if (tolower(Config.replPolicy[0]) == 'l') {
-            if (tolower(Config.replPolicy[1]) == 'f') {
-                debug(20, 1) ("Using LFUDA disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LFUDA);
-            } else if (tolower(Config.replPolicy[1]) == 'r') {
-                debug(20, 1) ("Using LRU heap disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LRU);
-            }
-        } else {
-            debug(20, 1) ("Unrecognized replacement_policy; using GDSF\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        }
-    } else {
-        debug(20, 1) ("Using default disk replacement policy (GDSF)\n");
-        sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-    }
-#else
-    sd->repl.lru.list.head = NULL;
-    sd->repl.lru.list.tail = NULL;
-#endif
+    sd->repl = createRemovalPolicy(Config.replPolicy);
 }
 
 void
-storeFsSetup_aufs(storefs_entry_t *storefs)
+storeFsSetup_aufs(storefs_entry_t * storefs)
 {
     storefs->parsefunc = storeAufsDirParse;
     storefs->reconfigurefunc = storeAufsDirReconfigure;
Index: squid/src/fs/coss/store_coss.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/coss/store_coss.h,v
retrieving revision 1.1.4.4
retrieving revision 1.1.4.4.2.1
diff -u -r1.1.4.4 -r1.1.4.4.2.1
--- squid/src/fs/coss/store_coss.h	11 Apr 2000 18:18:47 -0000	1.1.4.4
+++ squid/src/fs/coss/store_coss.h	14 May 2000 23:22:20 -0000	1.1.4.4.2.1
@@ -16,8 +16,8 @@
     int lockcount;
     char buffer[COSS_MEMBUF_SZ];
     struct _cossmembuf_flags {
-        unsigned int full:1;
-        unsigned int writing:1;
+	unsigned int full:1;
+	unsigned int writing:1;
     } flags;
     struct _cossmembuf *next;
 };
@@ -31,6 +31,16 @@
     int fd;
     int swaplog_fd;
     int numcollisions;
+    dlink_list index;
+    int count;
+    dlink_node *walk_current;
+};
+
+struct _cossindex {
+    /* Note: the dlink_node MUST be the first member of the structure.
+     * This member is later pointer typecasted to coss_index_node *.
+     */
+    dlink_node node;
 };
 
 
@@ -42,20 +52,21 @@
     size_t requestoffset;
     sfileno reqdiskoffset;
     struct {
-        unsigned int reading:1;
-        unsigned int writing:1;
+	unsigned int reading:1;
+	unsigned int writing:1;
     } flags;
 };
 
 typedef struct _cossmembuf CossMemBuf;
 typedef struct _cossinfo CossInfo;
 typedef struct _cossstate CossState;
+typedef struct _cossindex CossIndexNode;
 
 /* Whether the coss system has been setup or not */
 extern int coss_initialised;
-extern MemPool * coss_membuf_pool;
-extern MemPool * coss_state_pool;
-
+extern MemPool *coss_membuf_pool;
+extern MemPool *coss_state_pool;
+extern MemPool *coss_index_pool;
 
 /*
  * Store IO stuff
@@ -67,13 +78,15 @@
 extern STOBJWRITE storeCossWrite;
 extern STOBJUNLINK storeCossUnlink;
 
-extern off_t storeCossAllocate(SwapDir *SD, const StoreEntry *e, int which);
-extern void storeCossFree(StoreEntry *e);
-extern void storeCossMaintainSwapSpace(SwapDir *SD);
+extern off_t storeCossAllocate(SwapDir * SD, const StoreEntry * e, int which);
+extern void storeCossFree(StoreEntry * e);
+extern void storeCossMaintainSwapSpace(SwapDir * SD);
 extern void storeCossDirStats(SwapDir *, StoreEntry *);
-extern void storeCossDirDump(StoreEntry * entry, const char *name, SwapDir* s);
+extern void storeCossDirDump(StoreEntry * entry, const char *name, SwapDir * s);
 extern void storeCossDirFree(SwapDir *);
 extern SwapDir *storeCossDirPick(void);
+extern void storeCossAdd(SwapDir *, StoreEntry *);
+extern void storeCossRemove(SwapDir *, StoreEntry *);
 
 void storeFsSetup_ufs(storefs_entry_t *);
 
Index: squid/src/fs/coss/store_dir_coss.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/coss/store_dir_coss.c,v
retrieving revision 1.1.4.6.2.1
retrieving revision 1.1.4.6.2.2
diff -u -r1.1.4.6.2.1 -r1.1.4.6.2.2
--- squid/src/fs/coss/store_dir_coss.c	2 May 2000 22:50:29 -0000	1.1.4.6.2.1
+++ squid/src/fs/coss/store_dir_coss.c	14 May 2000 23:22:20 -0000	1.1.4.6.2.2
@@ -1,4 +1,4 @@
- 
+
 /*
  * $Id$
  *
@@ -39,13 +39,14 @@
 
 #define STORE_META_BUFSZ 4096
 
-extern void storeCossFlushMemBufs(SwapDir *SD);
+extern void storeCossFlushMemBufs(SwapDir * SD);
 
 int n_coss_dirs = 0;
 /* static int last_coss_pick_index = -1; */
 int coss_initialised = 0;
-MemPool * coss_membuf_pool = NULL;
-MemPool * coss_state_pool = NULL;
+MemPool *coss_membuf_pool = NULL;
+MemPool *coss_state_pool = NULL;
+MemPool *coss_index_pool = NULL;
 
 typedef struct _RebuildState RebuildState;
 struct _RebuildState {
@@ -72,7 +73,7 @@
 
 static char *storeCossDirSwapLogFile(SwapDir *, const char *);
 static EVH storeCossRebuildFromSwapLog;
-static StoreEntry *storeCossAddDiskRestore(SwapDir *SD,const cache_key *key,
+static StoreEntry *storeCossAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -87,9 +88,10 @@
 static FILE *storeCossDirOpenTmpSwapLog(SwapDir *, int *, int *);
 static STLOGOPEN storeCossDirOpenSwapLog;
 static STINIT storeCossDirInit;
-static STLOGCLEANOPEN storeCossDirWriteCleanOpen;
-static void storeCossDirWriteCleanClose(SwapDir * sd);
+static STLOGCLEANSTART storeCossDirWriteCleanStart;
+static STLOGCLEANNEXTENTRY storeCossDirCleanLogNextEntry;
 static STLOGCLEANWRITE storeCossDirWriteCleanEntry;
+static STLOGCLEANDONE storeCossDirWriteCleanDone;
 static STLOGCLOSE storeCossDirCloseSwapLog;
 static STLOGWRITE storeCossDirSwapLog;
 static STNEWFS storeCossDirNewfs;
@@ -106,31 +108,31 @@
     LOCAL_ARRAY(char, digit, 32);
     char *pathtmp2;
     if (Config.Log.swap) {
-        xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
-        while (index(pathtmp,'/'))
-            *index(pathtmp,'/')='.';
-        while (strlen(pathtmp) && pathtmp[strlen(pathtmp)-1]=='.')
-            pathtmp[strlen(pathtmp)-1]= '\0';
-        for(pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
-        snprintf(path, SQUID_MAXPATHLEN-64, Config.Log.swap, pathtmp2);
-        if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
-            strcat(path, ".");
-            snprintf(digit, 32, "%02d", sd->index);
-            strncat(path, digit, 3);
-        }
+	xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
+	while (index(pathtmp, '/'))
+	    *index(pathtmp, '/') = '.';
+	while (strlen(pathtmp) && pathtmp[strlen(pathtmp) - 1] == '.')
+	    pathtmp[strlen(pathtmp) - 1] = '\0';
+	for (pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+	snprintf(path, SQUID_MAXPATHLEN - 64, Config.Log.swap, pathtmp2);
+	if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
+	    strcat(path, ".");
+	    snprintf(digit, 32, "%02d", sd->index);
+	    strncat(path, digit, 3);
+	}
     } else {
-        xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
-        strcat(path, "/swap.state");
+	xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
+	strcat(path, "/swap.state");
     }
     if (ext)
-        strncat(path, ext, 16);
+	strncat(path, ext, 16);
     return path;
 }
 
 static void
 storeCossDirOpenSwapLog(SwapDir * sd)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     char *path;
     int fd;
     path = storeCossDirSwapLogFile(sd, NULL);
@@ -146,7 +148,7 @@
 static void
 storeCossDirCloseSwapLog(SwapDir * sd)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     if (cs->swaplog_fd < 0)	/* not open */
 	return;
     file_close(cs->swaplog_fd);
@@ -158,17 +160,40 @@
 static void
 storeCossDirInit(SwapDir * sd)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     storeCossDirOpenSwapLog(sd);
     storeCossDirRebuild(sd);
     cs->fd = file_open(sd->path, O_RDWR | O_CREAT);
     n_coss_dirs++;
 }
 
+void
+storeCossRemove(SwapDir *sd, StoreEntry *e)
+{
+    CossInfo *cs = (CossInfo *) sd->fsdata;
+    CossIndexNode *coss_node = e->repl.data;
+    e->repl.data = NULL;
+    dlinkDelete(&coss_node->node, &cs->index);
+    memPoolFree(coss_index_pool, coss_node);
+    cs->count -= 1;
+}
+
+void
+storeCossAdd(SwapDir *sd, StoreEntry *e)
+{
+    CossInfo *cs = (CossInfo *) sd->fsdata;
+    CossIndexNode *coss_node = memPoolAlloc(coss_index_pool);
+    assert(!e->repl.data);
+    e->repl.data = coss_node;
+    dlinkAdd(e, &coss_node->node, &cs->index);
+    cs->count += 1;
+}
+
 static void
 storeCossRebuildFromSwapLog(void *data)
 {
     RebuildState *rb = data;
+    SwapDir *sd = rb->sd;
     StoreEntry *e = NULL;
     storeSwapLogData s;
     size_t ss = sizeof(storeSwapLogData);
@@ -213,9 +238,9 @@
 		if (e->swap_filen > -1) {
 		    e->swap_filen = -1;
 		}
-                storeRelease(e);
-                /* Fake an unlink here, this is a bad hack :( */
-		dlinkDelete(&e->repl.lru, &rb->sd->repl.lru.list);
+		storeRelease(e);
+		/* Fake an unlink here, this is a bad hack :( */
+		storeCossRemove(sd, e);
 		rb->counts.objcount--;
 		rb->counts.cancelcount++;
 	    }
@@ -244,7 +269,7 @@
 	}
 	/* update store_swap_size */
 	rb->counts.objcount++;
-	e = storeCossAddDiskRestore(rb->sd,s.key,
+	e = storeCossAddDiskRestore(rb->sd, s.key,
 	    s.swap_filen,
 	    s.swap_file_sz,
 	    s.expires,
@@ -262,7 +287,7 @@
 /* Add a new object to the cache with empty memory copy and pointer to disk
  * use to rebuild store from disk. */
 static StoreEntry *
-storeCossAddDiskRestore(SwapDir *SD, const cache_key * key,
+storeCossAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -285,9 +310,6 @@
     e->swap_filen = file_number;
     e->swap_file_sz = swap_file_sz;
     e->lock_count = 0;
-#if !HEAP_REPLACEMENT
-    e->refcount = 0;
-#endif
     e->lastref = lastref;
     e->timestamp = timestamp;
     e->expires = expires;
@@ -300,7 +322,7 @@
     e->ping_status = PING_NONE;
     EBIT_CLR(e->flags, ENTRY_VALIDATED);
     storeHashInsert(e, key);	/* do it after we clear KEY_PRIVATE */
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
+    storeCossAdd(SD, e);
     e->swap_filen = storeCossAllocate(SD, e, COSS_ALLOC_NOTIFY);
     return e;
 }
@@ -323,7 +345,7 @@
     debug(20, 1) ("Rebuilding COSS storage in %s (%s)\n",
 	sd->path, clean ? "CLEAN" : "DIRTY");
     if (!clean || fp == NULL) {
-    	/* COSS cannot yet rebuild from a dirty state. If the log
+	/* COSS cannot yet rebuild from a dirty state. If the log
 	 * is dirty then the COSS contents is thrown away.
 	 * Why? I guess it is because some contents will be lost,
 	 * and COSS cannot verify this..
@@ -331,17 +353,17 @@
 	if (fp != NULL)
 	    fclose(fp);
 	storeCossDirCloseTmpSwapLog(rb->sd);
-        /*
+	/*
 	 * XXX Make sure we don't trigger an assertion if this is the first
 	 * storedir, since if we are, this call will cause storeRebuildComplete
 	 * to prematurely complete the rebuild process, and then some other
 	 * storedir will try to rebuild and eventually die.
 	 */
-        store_dirs_rebuilding++;
-        storeRebuildComplete(&rb->counts);
-        store_dirs_rebuilding--;
+	store_dirs_rebuilding++;
+	storeRebuildComplete(&rb->counts);
+	store_dirs_rebuilding--;
 	xfree(rb);
-        return;
+	return;
     }
     func = storeCossRebuildFromSwapLog;
     rb->log = fp;
@@ -354,7 +376,7 @@
 static void
 storeCossDirCloseTmpSwapLog(SwapDir * sd)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     char *swaplog_path = xstrdup(storeCossDirSwapLogFile(sd, NULL));
     char *new_path = xstrdup(storeCossDirSwapLogFile(sd, ".new"));
     int fd;
@@ -382,7 +404,7 @@
 static FILE *
 storeCossDirOpenTmpSwapLog(SwapDir * sd, int *clean_flag, int *zero_flag)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     char *swaplog_path = xstrdup(storeCossDirSwapLogFile(sd, NULL));
     char *clean_path = xstrdup(storeCossDirSwapLogFile(sd, ".last-clean"));
     char *new_path = xstrdup(storeCossDirSwapLogFile(sd, ".new"));
@@ -435,6 +457,7 @@
     char *outbuf;
     off_t outbuf_offset;
     int fd;
+    dlink_node *current;
 };
 
 #define CLEAN_BUF_SZ 16384
@@ -444,8 +467,9 @@
  * we succeed, and assign the 'func' and 'data' return pointers.
  */
 static int
-storeCossDirWriteCleanOpen(SwapDir * sd)
+storeCossDirWriteCleanStart(SwapDir * sd)
 {
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     struct _clean_state *state = xcalloc(1, sizeof(*state));
     struct stat sb;
     sd->log.clean.write = NULL;
@@ -460,6 +484,7 @@
     state->fd = file_open(state->new, O_WRONLY | O_CREAT | O_TRUNC);
     if (state->fd < 0)
 	return -1;
+    state->current = cs->index.tail;
     debug(20, 3) ("storeCOssDirWriteCleanLogs: opened %s, FD %d\n",
 	state->new, state->fd);
 #if HAVE_FCHMOD
@@ -468,22 +493,33 @@
 #endif
     sd->log.clean.write = storeCossDirWriteCleanEntry;
     sd->log.clean.state = state;
+
     return 0;
 }
 
+static const StoreEntry *
+storeCossDirCleanLogNextEntry(SwapDir * sd)
+{
+    struct _clean_state *state = sd->log.clean.state;
+    const StoreEntry *entry;
+    if (!state)
+	return NULL;
+    if (!state->current)
+	return NULL;
+    entry = (const StoreEntry *)state->current->data;
+    state->current = state->current->next;
+    return entry;
+}
+
 /*
  * "write" an entry to the clean log file.
  */
 static void
-storeCossDirWriteCleanEntry(const StoreEntry * e, SwapDir * sd)
+storeCossDirWriteCleanEntry(SwapDir *sd, const StoreEntry * e)
 {
     storeSwapLogData s;
     static size_t ss = sizeof(storeSwapLogData);
     struct _clean_state *state = sd->log.clean.state;
-    if (NULL == e) {
-	storeCossDirWriteCleanClose(sd);
-	return;
-    }
     memset(&s, '\0', ss);
     s.op = (char) SWAP_LOG_ADD;
     s.swap_filen = e->swap_filen;
@@ -515,7 +551,7 @@
 }
 
 static void
-storeCossDirWriteCleanClose(SwapDir * sd)
+storeCossDirWriteCleanDone(SwapDir * sd)
 {
     struct _clean_state *state = sd->log.clean.state;
     if (state->fd < 0)
@@ -568,7 +604,7 @@
 static void
 storeCossDirSwapLog(const SwapDir * sd, const StoreEntry * e, int op)
 {
-    CossInfo *cs = (CossInfo *)sd->fsdata;
+    CossInfo *cs = (CossInfo *) sd->fsdata;
     storeSwapLogData *s = xcalloc(1, sizeof(storeSwapLogData));
     s->op = (char) op;
     s->swap_filen = e->swap_filen;
@@ -595,17 +631,17 @@
     debug(47, 3) ("Creating swap space in %s\n", sd->path);
 }
 
-// we are shutting down, flush all membufs to disk
+/* we are shutting down, flush all membufs to disk */
 static void
-storeCossDirShutdown(SwapDir *SD)
+storeCossDirShutdown(SwapDir * SD)
 {
-    CossInfo *cs = (CossInfo *)SD->fsdata;
+    CossInfo *cs = (CossInfo *) SD->fsdata;
     CossMemBuf *t;
 
-    // we need to do this synchronously!
+    /* we need to do this synchronously! */
     for (t = cs->membufs; t; t = t->next) {
-        lseek(cs->fd, t->diskstart, SEEK_SET);
-        write(cs->fd, t->buffer, COSS_MEMBUF_SZ);
+	lseek(cs->fd, t->diskstart, SEEK_SET);
+	write(cs->fd, t->buffer, COSS_MEMBUF_SZ);
     }
     file_close(cs->fd);
     cs->fd = -1;
@@ -614,7 +650,6 @@
 	file_close(cs->swaplog_fd);
 	cs->swaplog_fd = -1;
     }
-
     n_coss_dirs--;
 }
 
@@ -627,46 +662,46 @@
  * done by the upper layers.
  */
 int
-storeCossDirCheckObj(SwapDir *SD, const StoreEntry *e)
+storeCossDirCheckObj(SwapDir * SD, const StoreEntry * e)
 {
-  /* Check if the object is a special object, we can't cache these */
-  if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
-      return -1;
+    /* Check if the object is a special object, we can't cache these */
+    if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
+	return -1;
 
-  /* Otherwise, we're ok */
-  /* Return 900 (90%) load */
-  return 900;
+    /* Otherwise, we're ok */
+    /* Return 900 (90%) load */
+    return 900;
 }
-     
+
 /* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
 
 void
-storeCossDirStats(SwapDir *SD, StoreEntry * sentry)
+storeCossDirStats(SwapDir * SD, StoreEntry * sentry)
 {
-    CossInfo *cs = (CossInfo *)SD->fsdata;
-    
+    CossInfo *cs = (CossInfo *) SD->fsdata;
+
     storeAppendPrintf(sentry, "\n");
     storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
     storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
     storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
-      100.0 * SD->cur_size / SD->max_size);
-    storeAppendPrintf(sentry, "Number of object collisions: %d\n", (int)cs->numcollisions);
+	100.0 * SD->cur_size / SD->max_size);
+    storeAppendPrintf(sentry, "Number of object collisions: %d\n", (int) cs->numcollisions);
 #if 0
     /* is this applicable? I Hope not .. */
     storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
-      SD->map->n_files_in_map, SD->map->max_n_files,
-      percent(SD->map->n_files_in_map, SD->map->max_n_files));
+	SD->map->n_files_in_map, SD->map->max_n_files,
+	percent(SD->map->n_files_in_map, SD->map->max_n_files));
 #endif
     storeAppendPrintf(sentry, "Flags:");
     if (SD->flags.selected)
-        storeAppendPrintf(sentry, " SELECTED");
+	storeAppendPrintf(sentry, " SELECTED");
     if (SD->flags.read_only)
-        storeAppendPrintf(sentry, " READ-ONLY");
+	storeAppendPrintf(sentry, " READ-ONLY");
     storeAppendPrintf(sentry, "\n");
 }
 
 static void
-storeCossDirParse(SwapDir *sd, int index, char *path)
+storeCossDirParse(SwapDir * sd, int index, char *path)
 {
     char *token;
     unsigned int i;
@@ -703,10 +738,10 @@
     sd->statfs = storeCossDirStats;
     sd->maintainfs = NULL;
     sd->checkobj = storeCossDirCheckObj;
-    sd->refobj = NULL;			/* LRU is done in storeCossRead */
+    sd->refobj = NULL;		/* LRU is done in storeCossRead */
     sd->unrefobj = NULL;
     sd->callback = NULL;
-    sd->sync = NULL; /* should we make it call the coss sync? */
+    sd->sync = NULL;		/* should we make it call the coss sync? */
 
     sd->obj.create = storeCossCreate;
     sd->obj.open = storeCossOpen;
@@ -718,8 +753,10 @@
     sd->log.open = storeCossDirOpenSwapLog;
     sd->log.close = storeCossDirCloseSwapLog;
     sd->log.write = storeCossDirSwapLog;
-    sd->log.clean.open = storeCossDirWriteCleanOpen;
+    sd->log.clean.start = storeCossDirWriteCleanStart;
     sd->log.clean.write = storeCossDirWriteCleanEntry;
+    sd->log.clean.nextentry = storeCossDirCleanLogNextEntry;
+    sd->log.clean.done = storeCossDirWriteCleanDone;
 
     cs->current_offset = 0;
     cs->fd = -1;
@@ -734,14 +771,13 @@
     cs->membufs->next = NULL;
     cs->membufs->SD = sd;
     cs->current_membuf = cs->membufs;
-
-    sd->repl.lru.list.head = NULL;
-    sd->repl.lru.list.tail = NULL;
+    cs->index.head = NULL;
+    cs->index.tail = NULL;
 }
 
 
 static void
-storeCossDirReconfigure(SwapDir *sd, int index, char *path)
+storeCossDirReconfigure(SwapDir * sd, int index, char *path)
 {
     char *token;
     unsigned int i;
@@ -757,15 +793,15 @@
 	    read_only = 1;
 
     if (size == sd->max_size)
-        debug (3, 1) ("Cache COSS dir '%s' size remains unchanged at %d KB\n", path, size);
+	debug(3, 1) ("Cache COSS dir '%s' size remains unchanged at %d KB\n", path, size);
     else {
-        debug (3, 1) ("Cache COSS dir '%s' size changed to %d KB\n", path, size);
-        sd->max_size = size;
+	debug(3, 1) ("Cache COSS dir '%s' size changed to %d KB\n", path, size);
+	sd->max_size = size;
     }
 
     if (read_only != sd->flags.read_only) {
-        debug (3, 1) ("Cache COSS dir '%s' now %s\n", path, read_only ? "Read-Only" : "Read-Write");
-        sd->flags.read_only = read_only;
+	debug(3, 1) ("Cache COSS dir '%s' now %s\n", path, read_only ? "Read-Only" : "Read-Write");
+	sd->flags.read_only = read_only;
     }
 }
 
@@ -774,7 +810,7 @@
 {
     storeAppendPrintf(entry, "%s %s %s %d\n",
 	name,
-        s->type,
+	s->type,
 	s->path,
 	s->max_size >> 20);
 }
@@ -783,40 +819,40 @@
 SwapDir *
 storeCossDirPick(void)
 {
-    int i,choosenext = 0;
+    int i, choosenext = 0;
     SwapDir *SD;
-  
+
     if (n_coss_dirs == 0)
-        return NULL;
+	return NULL;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];
-        if (SD->type == SWAPDIR_COSS) {
-            if ((last_coss_pick_index == -1) || (n_coss_dirs == 1)) {
-                last_coss_pick_index = i;
-                return SD;
-            } else if (choosenext) {
-                last_coss_pick_index = i;
-                return SD;
-            } else if (last_coss_pick_index == i) {
-                choosenext = 1;
-            }
-        }
+	if (SD->type == SWAPDIR_COSS) {
+	    if ((last_coss_pick_index == -1) || (n_coss_dirs == 1)) {
+		last_coss_pick_index = i;
+		return SD;
+	    } else if (choosenext) {
+		last_coss_pick_index = i;
+		return SD;
+	    } else if (last_coss_pick_index == i) {
+		choosenext = 1;
+	    }
+	}
     }
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];
-        if (SD->type == SWAPDIR_COSS) {
-            if ((last_coss_pick_index == -1) || (n_coss_dirs == 1)) {
-                last_coss_pick_index = i;
-                return SD;
-            } else if (choosenext) {
-                last_coss_pick_index = i;
-                return SD;
-            } else if (last_coss_pick_index == i) {
-                choosenext = 1;
-            }
-        }
+	if (SD->type == SWAPDIR_COSS) {
+	    if ((last_coss_pick_index == -1) || (n_coss_dirs == 1)) {
+		last_coss_pick_index = i;
+		return SD;
+	    } else if (choosenext) {
+		last_coss_pick_index = i;
+		return SD;
+	    } else if (last_coss_pick_index == i) {
+		choosenext = 1;
+	    }
+	}
     }
-    return NULL;               
+    return NULL;
 }
 #endif
 
@@ -832,7 +868,7 @@
 }
 
 void
-storeFsSetup_coss(storefs_entry_t *storefs)
+storeFsSetup_coss(storefs_entry_t * storefs)
 {
     assert(!coss_initialised);
 
@@ -841,6 +877,6 @@
     storefs->donefunc = storeCossDirDone;
     coss_membuf_pool = memPoolCreate("COSS Membuf data", sizeof(CossMemBuf));
     coss_state_pool = memPoolCreate("COSS IO State data", sizeof(CossState));
+    coss_index_pool = memPoolCreate("COSS index data", sizeof(CossIndexNode));
     coss_initialised = 1;
 }
-
